<?php

/**
 * Enter description here ...
 *
 * @package Logic
 *
 * @author  alessandrobartels
 */
class ValeTransporte{

    /**
     * Enter description here ...
     *
     * @param float	                $salario         Salario.
     * @param TkDateTime            $mes_competencia Data de competencia.
     * @param FpaitecalcfolhaEntity $item_de_calculo Item de calculo.
     * @param FpaassoceventoEntity 	$assoc_eventos   Associacao de evento.
     * @param FpaeventomEntity      $eventom         Evento.
     * @param integer               $nrOrg           Numero da Organizacao.
     *
     * @return void
     *
     * @author alessandrobartels -
     *         alessandrobartels - 27/06/2011 - Implementacao do NRORG no metodo retornaEvento
     */

    public static function calcula(
        $salario, TkDateTime $mes_competencia, FpaitecalcfolhaEntity $item_de_calculo,
        FpaassoceventoEntity $assoc_eventos, FpaeventomEntity $eventom, $nrOrg
    ){

        $nrevento =  $assoc_eventos->retornaEvento(FpatipoassoceveEntity::ASSOC_VALE_TRANSP_RECEB, $nrOrg);
        $evento_vale_recebido = $eventom->retornaEvento($nrevento);
        $nrevento =  $assoc_eventos->retornaEvento(FpatipoassoceveEntity::ASSOC_VALE_TRANSPORTE, $nrOrg);
        $evento_vale_descontado = $eventom->retornaEvento($nrevento);
        $itens = $item_de_calculo->retornaItens($evento_vale_recebido);
        $base = $item_de_calculo->calculaIncidencias(
            FpatipoincideEntity::INC_VALE_TRANSP, $mes_competencia, $eventom
        );
        if ($base === 0.0) {
            $base = $salario;
        }

        foreach ($itens as $indice) {
            $referencia_recebida = $item_de_calculo->retornaReferencia($indice);
            $valor_recebido = $item_de_calculo->retornaValor($indice);
            if ($referencia_recebida > 0) {
                $valor_descontado = ($base / 30) * $referencia_recebida;
            } else {
                $valor_descontado = $base;
            }

            // Rever @todo Parametrizar percentual de vale transporte.
            $valor_descontado = $valor_descontado /100 * 6;

            if ($valor_descontado > $valor_recebido) {
                $valor_descontado = $valor_recebido;
            }

            $dtocorrencia = new TkDateTime($item_de_calculo->retornaDtocorrencia($indice));

            // Echo $base.'|REF'.$referencia_recebida.'|dESCONTADO'.$valor_descontado.' |
            // RECEBIDO '.$valor_recebido.'<br/>';.
            $item_de_calculo->geraEvento(
                $evento_vale_descontado, $dtocorrencia, $valor_descontado, $referencia_recebida, 1
            );

            unset($dtocorrencia);
        }
    }


}

