CREATE OR REPLACE PROCEDURE ARQUIVO_GIA_PR(
   P_CDIMPOSTO     IN IMPOSTO.CDIMPOSTO%TYPE,
   P_CDEMPRESA     IN EMPRESA.CDEMPRESA%TYPE,
   P_CDINSCESTA    IN EMPRESA.CDINSCESTA%TYPE,
   P_CDLIVROMAG    IN LIVROMAGNETICO.CDLIVROMAG%TYPE,
   P_TIPOITEM      IN TIPOITEMPROD.CDTPITEMPROD%TYPE,
   P_DTINICIAL     IN NOTAFISCAL.DTENTRSAID%TYPE,
   P_DTFINAL       IN NOTAFISCAL.DTENTRSAID%TYPE,
   P_TIPO          IN IMPOSTO.CDIMPOSTO%TYPE,
   P_GERAINV       IN IMPOSTONF.CDFISCALNF%TYPE,
   P_FUNC          IN ARQMAGNETICO.NRSEQARQMAG%TYPE,
   P_FOLHA         IN IMPOSTONF.VRCONTABILNF%TYPE,
   P_NRSEQARQMAG   IN ARQMAGNETICO.NRSEQARQMAG%TYPE,
   P_DESPESA       IN IMPOSTONF.VRCONTABILNF%TYPE)
AS
   V_NRSEQUMAPAPU  VARCHAR2(10);
   V_REGISTRO1     VARCHAR2(1000);
   V_CABREG2       VARCHAR2(50);
   V_VRINVFISCAL   NUMBER;
   V_VRTOTCONT_E   NUMBER;
   V_VRTOTBASE_E   NUMBER;
   V_VRTOTCONT_S   NUMBER;
   V_VRTOTBASE_S   NUMBER;
   V_CAMPO_51      NUMBER;
   V_CAMPO_52      NUMBER;
   V_CAMPO_53      NUMBER;
   V_CAMPO_54      NUMBER;
   V_CAMPO_55      NUMBER;
   V_CAMPO_56      NUMBER;
   V_CAMPO_57      NUMBER;
   V_CAMPO_58      NUMBER;
   V_CAMPO_59      NUMBER;
   V_VRTOTDEBI     NUMBER;
   V_CAMPO_61      NUMBER;
   V_CAMPO_62      NUMBER;
   V_CAMPO_63      NUMBER;
   V_CAMPO_64      NUMBER;
   V_CAMPO_65      NUMBER;
   V_CAMPO_66      NUMBER;
   V_CAMPO_67      NUMBER;
   V_CAMPO_68      NUMBER;
   V_CAMPO_69      NUMBER;
   V_VRTOTCRED     NUMBER;
   V_CAMPO_80      NUMBER;
   V_CAMPO_90      NUMBER;
   V_CONTREG       NUMBER;
   V_VRITEMMAPR    NUMBER;
   V_COUNT         NUMBER; 
BEGIN
   V_CONTREG := 0;
   BEGIN
     SELECT MAX(NRSEQUMAPAPU)
       INTO V_NRSEQUMAPAPU
       FROM MAPAAPURAC MP
      WHERE MP.CDEMPRESA  = P_CDEMPRESA
        AND MP.CDINSCESTA = P_CDINSCESTA
        AND MP.CDIMPOSTO  = P_CDIMPOSTO
        AND TO_CHAR(MP.DTINIPERIODO, 'YYYYMM') BETWEEN TO_CHAR(P_DTINICIAL, 'YYYYMM') AND TO_CHAR(P_DTFINAL, 'YYYYMM');
   EXCEPTION
     WHEN NO_DATA_FOUND THEN
        V_NRSEQUMAPAPU := NULL;
   END;
   IF P_GERAINV = 'S' THEN
      BEGIN
        SELECT SUM(VRTOTINVFISC)
          INTO V_VRINVFISCAL
          FROM INVENTFISC
         WHERE CDEMPRESA = P_CDEMPRESA
           AND CDINSCESTA = P_CDINSCESTA
           AND DTINVEFISCAL <= '31/12/'||TO_CHAR(P_DTINICIAL,'YYYY');
      EXCEPTION
        WHEN NO_DATA_FOUND THEN
           V_VRINVFISCAL := 0;
      END;
   ELSE
      V_VRINVFISCAL := 0;
   END IF;
   /******** CABECALHO ********/
   BEGIN
     SELECT ('1'                                                                         || /* Tipo do Registro */
             LPAD(M.CDINSCESTA, 10, '0')                                                 || /* Inscrio Estadual */
             TO_CHAR(M.DTINIPERIODO,'YYYYMM')                                            || /* Data de Referncia */
             NVL(P_TIPO,'43')                                                            || /* Tipo da GIA-ICMS */
             LPAD(REPLACE(REPLACE(C.NRCRCCONT2,'/',''),'-',''),10,' ')                   || /* CRC Contabilista */
             LTRIM(REPLACE(TO_CHAR(ROUND(V_VRINVFISCAL,2), '0000000000000.00'), '.', ''))|| /* Valor Estoque */
             LPAD(NVL(P_FUNC,'0'),5,'0')                                                 || /* Funcionarios */
             LTRIM(REPLACE(TO_CHAR(ROUND(NVL(P_FOLHA,0),2), '0000000000000.00'), '.', ''))  /* Folha de Pagamento */)
       INTO V_REGISTRO1
       FROM MAPAAPURAC M, INSCRESTAD I, CONTADOR C
      WHERE M.NRSEQUMAPAPU = V_NRSEQUMAPAPU
        AND M.CDEMPRESA    = I.CDEMPRESA
        AND M.CDINSCESTA   = I.CDINSCESTA
        AND I.CDCONTADOR2  = C.CDCONTADOR2(+);
   EXCEPTION
     WHEN NO_DATA_FOUND THEN
        V_REGISTRO1 := NULL;
   END;

   /****** FIM CABECALHO ******/
   /***** REGISTRO TIPO 2 *****/
   BEGIN
     SELECT ('2'                             || /* Tipo do Registro */
             P_CDINSCESTA                    || /* Inscrio Estadual */
             TO_CHAR(P_DTINICIAL,'YYYYMM')   || /* Data de Referncia */
             P_TIPO                             /* Tipo da GIA-ICMS */)
       INTO V_CABREG2
       FROM DUAL;
   EXCEPTION
     WHEN NO_DATA_FOUND THEN
        V_CABREG2 := NULL;
   END;
   /*** QUADRO 05 - INFORMAES FISCAIS ***/
   /* CAMPO 02 - Valor das Despesas */
   IF (P_DESPESA > 0) THEN
      INSERT INTO ARQMAGNETICO
        (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
      VALUES
        (LPAD('02',10,'0'), V_CABREG2||'02'||LTRIM(REPLACE(REPLACE(TO_CHAR(NVL(P_DESPESA,0), '0000000000000.00'), '.', ''), ',','')), P_NRSEQARQMAG);
      V_CONTREG := V_CONTREG + 1;
   END IF;

   /* CAMPO 04 - NO FAZER */
   /* CAMPO 06 - NO FAZER */
   /* CAMPO 10 - NO FAZER */

   /*** QUADRO 08 - VALORES FISCAIS - ENTRADAS ***/
   V_VRTOTCONT_E := 0;
   V_VRTOTBASE_E := 0;
   FOR C_ENTRADAS IN (SELECT C.CDLAYOUTLMAG,
                             LTRIM(REPLACE(TO_CHAR(ROUND(SUM(I.VRCONTABILNF),2), '0000000000000.00'), '.', '')) AS VR_CONT,
                             LTRIM(REPLACE(TO_CHAR(ROUND(SUM(I.VRBASECALCNF),2), '0000000000000.00'), '.', '')) AS VR_BASE,
                             SUM(I.VRCONTABILNF) AS VRCONTABIL, SUM(I.VRBASECALCNF) AS VRBASECALC
                        FROM IMPOSTONF I, CFOPLIVROMAG C
                       WHERE I.CDFILIAL     <> 'X'
                         AND I.NRLANCTONF   <> 'X'
                         AND I.NRSEQUMAPAPU = V_NRSEQUMAPAPU
                         AND C.CDCFOPLMAG   = I.CDFISCOPERNF
                         AND C.CDLIVROMAG   = P_CDLIVROMAG
                         AND C.CDLAYOUTLMAG IN ('011','013','014','015','016','017','018','019')
                       GROUP BY C.CDLAYOUTLMAG) LOOP

      IF SUBSTR(C_ENTRADAS.CDLAYOUTLMAG,3,1) = '1' THEN
         IF (C_ENTRADAS.VR_CONT > 0) THEN
            INSERT INTO ARQMAGNETICO
              (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
            VALUES
              (LPAD('11',10,'0'), V_CABREG2||'11'||C_ENTRADAS.VR_CONT, P_NRSEQARQMAG);
            V_CONTREG := V_CONTREG + 1;
         END IF;
         IF (C_ENTRADAS.VR_BASE > 0) THEN
            INSERT INTO ARQMAGNETICO
              (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
            VALUES
              (LPAD('21',10,'0'), V_CABREG2||'21'||C_ENTRADAS.VR_BASE, P_NRSEQARQMAG);
            V_CONTREG := V_CONTREG + 1;
         END IF;
      ELSIF SUBSTR(C_ENTRADAS.CDLAYOUTLMAG,3,1) = '3' THEN
         IF (C_ENTRADAS.VR_CONT > 0) THEN
            INSERT INTO ARQMAGNETICO
              (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
            VALUES
              (LPAD('13',10,'0'), V_CABREG2||'13'||C_ENTRADAS.VR_CONT, P_NRSEQARQMAG);
            V_CONTREG := V_CONTREG + 1;
         END IF;
         IF (C_ENTRADAS.VR_BASE > 0) THEN
            INSERT INTO ARQMAGNETICO
              (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
            VALUES
              (LPAD('23',10,'0'), V_CABREG2||'23'||C_ENTRADAS.VR_BASE, P_NRSEQARQMAG);
            V_CONTREG := V_CONTREG + 1;
         END IF;
      ELSIF SUBSTR(C_ENTRADAS.CDLAYOUTLMAG,3,1) = '4' THEN
         IF (C_ENTRADAS.VR_CONT > 0) THEN
            INSERT INTO ARQMAGNETICO
              (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
            VALUES
              (LPAD('14',10,'0'), V_CABREG2||'14'||C_ENTRADAS.VR_CONT, P_NRSEQARQMAG);
            V_CONTREG := V_CONTREG + 1;
         END IF;
         IF (C_ENTRADAS.VR_BASE > 0) THEN
            INSERT INTO ARQMAGNETICO
              (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
            VALUES
              (LPAD('24',10,'0'), V_CABREG2||'24'||C_ENTRADAS.VR_BASE, P_NRSEQARQMAG);
            V_CONTREG := V_CONTREG + 1;
         END IF;
      ELSIF SUBSTR(C_ENTRADAS.CDLAYOUTLMAG,3,1) = '5' THEN
         IF (C_ENTRADAS.VR_CONT > 0) THEN
            INSERT INTO ARQMAGNETICO
              (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
            VALUES
              (LPAD('15',10,'0'), V_CABREG2||'15'||C_ENTRADAS.VR_CONT, P_NRSEQARQMAG);
            V_CONTREG := V_CONTREG + 1;
         END IF;
         IF (C_ENTRADAS.VR_BASE > 0) THEN
            INSERT INTO ARQMAGNETICO
              (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
            VALUES
              (LPAD('25',10,'0'), V_CABREG2||'25'||C_ENTRADAS.VR_BASE, P_NRSEQARQMAG);
            V_CONTREG := V_CONTREG + 1;
         END IF;
      ELSIF SUBSTR(C_ENTRADAS.CDLAYOUTLMAG,3,1) = '6' THEN
         IF (C_ENTRADAS.VR_CONT > 0) THEN
            INSERT INTO ARQMAGNETICO
              (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
            VALUES
              (LPAD('16',10,'0'), V_CABREG2||'16'||C_ENTRADAS.VR_CONT, P_NRSEQARQMAG);
            V_CONTREG := V_CONTREG + 1;
         END IF;
         IF (C_ENTRADAS.VR_BASE > 0) THEN
            INSERT INTO ARQMAGNETICO
              (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
            VALUES
              (LPAD('26',10,'0'), V_CABREG2||'26'||C_ENTRADAS.VR_BASE, P_NRSEQARQMAG);
            V_CONTREG := V_CONTREG + 1;
         END IF;
      ELSIF SUBSTR(C_ENTRADAS.CDLAYOUTLMAG,3,1) = '7' THEN
         IF (C_ENTRADAS.VR_CONT > 0) THEN
            INSERT INTO ARQMAGNETICO
              (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
            VALUES
              (LPAD('17',10,'0'), V_CABREG2||'17'||C_ENTRADAS.VR_CONT, P_NRSEQARQMAG);
            V_CONTREG := V_CONTREG + 1;
         END IF;
         IF (C_ENTRADAS.VR_BASE > 0) THEN
            INSERT INTO ARQMAGNETICO
              (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
            VALUES
              (LPAD('27',10,'0'), V_CABREG2||'27'||C_ENTRADAS.VR_BASE, P_NRSEQARQMAG);
            V_CONTREG := V_CONTREG + 1;
         END IF;
      ELSIF SUBSTR(C_ENTRADAS.CDLAYOUTLMAG,3,1) = '8' THEN
         IF (C_ENTRADAS.VR_CONT > 0) THEN
            INSERT INTO ARQMAGNETICO
              (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
            VALUES
              (LPAD('18',10,'0'), V_CABREG2||'18'||C_ENTRADAS.VR_CONT, P_NRSEQARQMAG);
            V_CONTREG := V_CONTREG + 1;
         END IF;
         IF (C_ENTRADAS.VR_BASE > 0) THEN
            INSERT INTO ARQMAGNETICO
              (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
            VALUES
              (LPAD('28',10,'0'), V_CABREG2||'28'||C_ENTRADAS.VR_BASE, P_NRSEQARQMAG);
            V_CONTREG := V_CONTREG + 1;
         END IF;
      ELSIF SUBSTR(C_ENTRADAS.CDLAYOUTLMAG,3,1) = '9' THEN
         IF (C_ENTRADAS.VR_CONT > 0) THEN
            INSERT INTO ARQMAGNETICO
              (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
            VALUES
              (LPAD('19',10,'0'), V_CABREG2||'19'||C_ENTRADAS.VR_CONT, P_NRSEQARQMAG);
            V_CONTREG := V_CONTREG + 1;
         END IF;
         IF (C_ENTRADAS.VR_BASE > 0) THEN
            INSERT INTO ARQMAGNETICO
              (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
            VALUES
              (LPAD('29',10,'0'), V_CABREG2||'29'||C_ENTRADAS.VR_BASE, P_NRSEQARQMAG);
            V_CONTREG := V_CONTREG + 1;
         END IF;
      END IF;
      V_VRTOTCONT_E := V_VRTOTCONT_E + C_ENTRADAS.VRCONTABIL;
      V_VRTOTBASE_E := V_VRTOTBASE_E + C_ENTRADAS.VRBASECALC;
   END LOOP;
   IF (V_VRTOTCONT_E > 0) THEN
      INSERT INTO ARQMAGNETICO
        (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
      VALUES
        (LPAD('20',10,'0'),
         V_CABREG2||'20'||LTRIM(REPLACE(TO_CHAR(ROUND(V_VRTOTCONT_E,2),'0000000000000.00'),'.','')), P_NRSEQARQMAG);
      V_CONTREG := V_CONTREG + 1;
   END IF;
   IF (V_VRTOTBASE_E > 0) THEN
      INSERT INTO ARQMAGNETICO
        (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
      VALUES
        (LPAD('30',10,'0'),
         V_CABREG2||'30'||LTRIM(REPLACE(TO_CHAR(ROUND(V_VRTOTBASE_E,2),'0000000000000.00'),'.','')), P_NRSEQARQMAG);
      V_CONTREG := V_CONTREG + 1;
   END IF;

   /*** QUADRO 08 - VALORES FISCAIS - SAIDAS ***/
   V_VRTOTCONT_S := 0;
   V_VRTOTBASE_S := 0;
   FOR C_SAIDAS IN (SELECT C.CDLAYOUTLMAG,
                           LTRIM(REPLACE(TO_CHAR(ROUND(SUM(I.VRCONTABILNF),2), '0000000000000.00'), '.', '')) AS VR_CONT,
                           LTRIM(REPLACE(TO_CHAR(ROUND(SUM(I.VRBASECALCNF),2), '0000000000000.00'), '.', '')) AS VR_BASE,
                           SUM(I.VRCONTABILNF) AS VRCONTABIL, SUM(I.VRBASECALCNF) AS VRBASECALC
                      FROM IMPOSTONF I, CFOPLIVROMAG C
                     WHERE I.CDFILIAL     <> 'X'
                       AND I.NRLANCTONF   <> 'X'
                       AND I.NRSEQUMAPAPU = V_NRSEQUMAPAPU
                       AND C.CDCFOPLMAG   = I.CDFISCOPERNF
                       AND C.CDLIVROMAG   = P_CDLIVROMAG
                       AND C.CDLAYOUTLMAG IN ('031','033','034','035','036','039')
                     GROUP BY C.CDLAYOUTLMAG) LOOP
      IF SUBSTR(C_SAIDAS.CDLAYOUTLMAG,3,1) = '1' THEN
         IF (C_SAIDAS.VR_CONT > 0) THEN
            INSERT INTO ARQMAGNETICO
              (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
            VALUES
              (LPAD('31',10,'0'), V_CABREG2||'31'||C_SAIDAS.VR_CONT, P_NRSEQARQMAG);
            V_CONTREG := V_CONTREG + 1;
         END IF;
         IF (C_SAIDAS.VR_BASE > 0) THEN
            INSERT INTO ARQMAGNETICO
              (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
            VALUES
              (LPAD('41',10,'0'), V_CABREG2||'41'||C_SAIDAS.VR_BASE, P_NRSEQARQMAG);
            V_CONTREG := V_CONTREG + 1;
         END IF;
      ELSIF SUBSTR(C_SAIDAS.CDLAYOUTLMAG,3,1) = '3' THEN
         IF (C_SAIDAS.VR_CONT > 0) THEN
            INSERT INTO ARQMAGNETICO
              (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
            VALUES
              (LPAD('33',10,'0'), V_CABREG2||'33'||C_SAIDAS.VR_CONT, P_NRSEQARQMAG);
            V_CONTREG := V_CONTREG + 1;
         END IF;
         IF (C_SAIDAS.VR_BASE > 0) THEN
            INSERT INTO ARQMAGNETICO
              (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
            VALUES
              (LPAD('43',10,'0'), V_CABREG2||'43'||C_SAIDAS.VR_BASE, P_NRSEQARQMAG);
            V_CONTREG := V_CONTREG + 1;
         END IF;
      ELSIF SUBSTR(C_SAIDAS.CDLAYOUTLMAG,3,1) = '4' THEN
         IF (C_SAIDAS.VR_CONT > 0) THEN
            INSERT INTO ARQMAGNETICO
              (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
            VALUES
              (LPAD('34',10,'0'), V_CABREG2||'34'||C_SAIDAS.VR_CONT, P_NRSEQARQMAG);
            V_CONTREG := V_CONTREG + 1;
         END IF;
         IF (C_SAIDAS.VR_BASE > 0) THEN
            INSERT INTO ARQMAGNETICO
              (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
            VALUES
              (LPAD('44',10,'0'), V_CABREG2||'44'||C_SAIDAS.VR_BASE, P_NRSEQARQMAG);
            V_CONTREG := V_CONTREG + 1;
         END IF;
      ELSIF SUBSTR(C_SAIDAS.CDLAYOUTLMAG,3,1) = '5' THEN
         IF (C_SAIDAS.VR_CONT > 0) THEN
            INSERT INTO ARQMAGNETICO
              (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
            VALUES
              (LPAD('35',10,'0'), V_CABREG2||'35'||C_SAIDAS.VR_CONT, P_NRSEQARQMAG);
            V_CONTREG := V_CONTREG + 1;
         END IF;
         IF (C_SAIDAS.VR_BASE > 0) THEN
            INSERT INTO ARQMAGNETICO
              (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
            VALUES
              (LPAD('45',10,'0'), V_CABREG2||'45'||C_SAIDAS.VR_BASE, P_NRSEQARQMAG);
            V_CONTREG := V_CONTREG + 1;
         END IF;
      ELSIF SUBSTR(C_SAIDAS.CDLAYOUTLMAG,3,1) = '6' THEN
         IF (C_SAIDAS.VR_CONT > 0) THEN
            INSERT INTO ARQMAGNETICO
              (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
            VALUES
              (LPAD('36',10,'0'), V_CABREG2||'36'||C_SAIDAS.VR_CONT, P_NRSEQARQMAG);
            V_CONTREG := V_CONTREG + 1;
         END IF;
         IF (C_SAIDAS.VR_BASE > 0) THEN
            INSERT INTO ARQMAGNETICO
              (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
            VALUES
              (LPAD('46',10,'0'), V_CABREG2||'46'||C_SAIDAS.VR_BASE, P_NRSEQARQMAG);
            V_CONTREG := V_CONTREG + 1;
         END IF;
      ELSIF SUBSTR(C_SAIDAS.CDLAYOUTLMAG,3,1) = '9' THEN
         IF (C_SAIDAS.VR_CONT > 0) THEN
            INSERT INTO ARQMAGNETICO
              (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
            VALUES
              (LPAD('39',10,'0'), V_CABREG2||'39'||C_SAIDAS.VR_CONT, P_NRSEQARQMAG);
            V_CONTREG := V_CONTREG + 1;
         END IF;
         IF (C_SAIDAS.VR_BASE > 0) THEN
            INSERT INTO ARQMAGNETICO
              (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
            VALUES
              (LPAD('49',10,'0'), V_CABREG2||'49'||C_SAIDAS.VR_BASE, P_NRSEQARQMAG);
            V_CONTREG := V_CONTREG + 1;
         END IF;
      END IF;
      V_VRTOTCONT_S := V_VRTOTCONT_S + C_SAIDAS.VRCONTABIL;
      V_VRTOTBASE_S := V_VRTOTBASE_S + C_SAIDAS.VRBASECALC;
   END LOOP;
   IF (V_VRTOTCONT_S > 0) THEN
      INSERT INTO ARQMAGNETICO
        (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
      VALUES
        (LPAD('40',10,'0'),V_CABREG2||'40'||LTRIM(REPLACE(TO_CHAR(ROUND(V_VRTOTCONT_S,2),'0000000000000.00'),'.','')),P_NRSEQARQMAG);
      V_CONTREG := V_CONTREG + 1;
   END IF;
   IF (V_VRTOTBASE_S > 0) THEN
      INSERT INTO ARQMAGNETICO
        (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
      VALUES
        (LPAD('50',10,'0'),
         V_CABREG2||'50'||LTRIM(REPLACE(TO_CHAR(ROUND(V_VRTOTBASE_S,2), '0000000000000.00'), '.', '')),
         P_NRSEQARQMAG);
      V_CONTREG := V_CONTREG + 1;
   END IF;
   /* busca valor do difal em outros debitos */
   SELECT SUM(VRITEMMAPR)
     INTO V_VRITEMMAPR
     FROM ITMAPARECUP
    WHERE NRSEQUMAPAPU = V_NRSEQUMAPAPU
      AND UPPER(DSITEMMAPR) LIKE '%DIFERENCIAL%'
      AND IDTIPOITMAPR = 'OD';
   BEGIN
     SELECT MR.VRNORMDEBI AS CAMPO_51,
            MR.VROUTRDEBI AS CAMPO_52,
            MR.VRESTOCRED AS CAMPO_53,
            MR.VRDIFALIQU AS CAMPO_54,
            0 AS CAMPO_56,
            0 AS CAMPO_58,
            MR.VRSLDCRANTE AS CAMPO_61,
            MR.VRNORMCRED AS CAMPO_62,
            MR.VRESTODEBI AS CAMPO_64,
            0 AS CAMPO_68,
            MR.VRSALDOCRED AS CAMPO_80,
            MR.VRSALDODEBI AS CAMPO_90
       INTO V_CAMPO_51,V_CAMPO_52,V_CAMPO_53,V_CAMPO_54,V_CAMPO_56,V_CAMPO_58,
            V_CAMPO_61,V_CAMPO_62,V_CAMPO_64,V_CAMPO_68,
            V_CAMPO_80,V_CAMPO_90
       FROM MAPARECUP MR
      WHERE NRSEQUMAPAPU = V_NRSEQUMAPAPU;
   EXCEPTION
     WHEN NO_DATA_FOUND THEN
        V_CAMPO_51:=0;V_CAMPO_52:=0;V_CAMPO_53:=0;V_CAMPO_54:=0;V_CAMPO_56:=0;V_CAMPO_58:=0;
        V_CAMPO_61:=0;V_CAMPO_62:=0;V_CAMPO_64:=0;V_CAMPO_68:=0;
        V_CAMPO_80:=0;V_CAMPO_90:=0;
   END;
   BEGIN
     SELECT SUM(NT.VRCAMPO55) AS CAMPO_55,
            SUM(NT.VRCAMPO57) AS CAMPO_57,
            SUM(NT.VRCAMPO59) AS CAMPO_59,
            SUM(NT.VRCAMPO63) AS CAMPO_63,
            SUM(NT.VRCAMPO65) AS CAMPO_65,
            SUM(NT.VRCAMPO66) AS CAMPO_66,
            SUM(NT.VRCAMPO69) AS CAMPO_69
       INTO V_CAMPO_55,V_CAMPO_57,V_CAMPO_59,
            V_CAMPO_63,V_CAMPO_65,V_CAMPO_66,V_CAMPO_69
       FROM (SELECT DECODE(C.CDLAYOUTLMAG,'055',SUM(I.VRIMPOSTONF),0) AS VRCAMPO55,
                    DECODE(C.CDLAYOUTLMAG,'057',SUM(I.VRIMPOSTONF),0) AS VRCAMPO57,
                    DECODE(C.CDLAYOUTLMAG,'059',SUM(I.VRIMPOSTONF),0) AS VRCAMPO59,
                    DECODE(C.CDLAYOUTLMAG,'063',SUM(I.VRIMPOSTONF),0) AS VRCAMPO63,
                    DECODE(C.CDLAYOUTLMAG,'065',SUM(I.VRIMPOSTONF),0) AS VRCAMPO65,
                    DECODE(C.CDLAYOUTLMAG,'066',SUM(I.VRIMPOSTONF),0) AS VRCAMPO66,
                    DECODE(C.CDLAYOUTLMAG,'069',SUM(I.VRIMPOSTONF),0) AS VRCAMPO69
               FROM IMPOSTONF I, CFOPLIVROMAG C
              WHERE I.CDFILIAL    <> 'X'
                AND I.NRLANCTONF  <> 'X'
                AND I.NRSEQUMAPAPU = V_NRSEQUMAPAPU
                AND C.CDCFOPLMAG   = I.CDFISCOPERNF
                AND C.CDLIVROMAG   = P_CDLIVROMAG
              GROUP BY C.CDLAYOUTLMAG) NT;
   EXCEPTION
     WHEN NO_DATA_FOUND THEN
        V_CAMPO_55:=0;V_CAMPO_57:=0;V_CAMPO_59:=0;
        V_CAMPO_63:=0;V_CAMPO_65:=0;V_CAMPO_66:=0;V_CAMPO_69:=0;
   END;
   V_CAMPO_67 := 0;
   IF P_TIPOITEM IS NOT NULL THEN
      BEGIN
         SELECT SUM(IP.VRIMPOSTOIT) AS CAMPO_67
           INTO V_CAMPO_67
           FROM IMPOSTONF IM, ITEMPROIMPOS IP, ITEMPRODUTO IT, RELACPRODITGEN RP
          WHERE IM.NRSEQUMAPAPU = V_NRSEQUMAPAPU
            AND IM.CDFILIAL = IP.CDFILIAL
            AND IM.NRLANCTONF = IP.NRLANCTONF
            AND IM.CDIMPOSTO = IP.CDIMPOSTO
            AND IP.CDFILIAL = IT.CDFILIAL
            AND IP.NRLANCTONF = IT.NRLANCTONF
            AND IP.NRSEQITPROD = IT.NRSEQITPROD
            AND IT.CDPRODUTO = RP.CDPRODUTO
            AND RP.CDLIVROMAG = P_CDLIVROMAG
            AND RP.CDTPITEMPROD = P_TIPOITEM;
      EXCEPTION
         WHEN NO_DATA_FOUND THEN
            V_CAMPO_67 := 0;
      END;
   END IF;
   /*** QUADRO 09 - DBITOS DE ICMS ***/
   IF (V_CAMPO_51 > 0) THEN
      INSERT INTO ARQMAGNETICO
        (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
      VALUES
        (LPAD('51',10,'0'), V_CABREG2||'51'||LTRIM(REPLACE(TO_CHAR(ROUND(V_CAMPO_51,2),'0000000000000.00'),'.','')), P_NRSEQARQMAG);
      V_CONTREG := V_CONTREG + 1;
   END IF;
   IF ( ROUND(NVL(V_CAMPO_52,0)-NVL(V_VRITEMMAPR,0),2) > 0) THEN
      INSERT INTO ARQMAGNETICO
        (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
      VALUES
        (LPAD('52',10,'0'), V_CABREG2||'52'||LTRIM(REPLACE(TO_CHAR(ROUND(NVL(V_CAMPO_52,0)-NVL(V_VRITEMMAPR,0),2),'0000000000000.00'),'.','')), P_NRSEQARQMAG);
      V_CONTREG := V_CONTREG + 1;
   END IF;
   IF (V_CAMPO_53 > 0) THEN
      INSERT INTO ARQMAGNETICO
        (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
      VALUES
        (LPAD('53',10,'0'), V_CABREG2||'53'||LTRIM(REPLACE(TO_CHAR(ROUND(V_CAMPO_53,2),'0000000000000.00'),'.','')), P_NRSEQARQMAG);
      V_CONTREG := V_CONTREG + 1;
   END IF;
   IF ( (V_CAMPO_54 > 0) OR (NVL(V_VRITEMMAPR,0)) > 0) THEN
      INSERT INTO ARQMAGNETICO
        (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
      VALUES
        (LPAD('54',10,'0'), V_CABREG2||'54'||LTRIM(REPLACE(TO_CHAR(ROUND(NVL(V_CAMPO_54,0)+NVL(V_VRITEMMAPR,0),2),'0000000000000.00'),'.','')), P_NRSEQARQMAG);
      V_CONTREG := V_CONTREG + 1;
   END IF;
   IF (V_CAMPO_55 > 0) THEN
      INSERT INTO ARQMAGNETICO
        (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
      VALUES
        (LPAD('55',10,'0'), V_CABREG2||'55'||LTRIM(REPLACE(TO_CHAR(ROUND(V_CAMPO_55,2),'0000000000000.00'),'.','')), P_NRSEQARQMAG);
      V_CONTREG := V_CONTREG + 1;
   END IF;
   IF (V_CAMPO_56 > 0) THEN
      INSERT INTO ARQMAGNETICO
        (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
      VALUES
        (LPAD('56',10,'0'), V_CABREG2||'56'||LTRIM(REPLACE(TO_CHAR(ROUND(V_CAMPO_56,2),'0000000000000.00'),'.','')), P_NRSEQARQMAG);
      V_CONTREG := V_CONTREG + 1;
   END IF;
   IF (V_CAMPO_57 > 0) THEN
      INSERT INTO ARQMAGNETICO
        (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
      VALUES
        (LPAD('57',10,'0'), V_CABREG2||'57'||LTRIM(REPLACE(TO_CHAR(ROUND(V_CAMPO_57,2),'0000000000000.00'),'.','')), P_NRSEQARQMAG);
      V_CONTREG := V_CONTREG + 1;
   END IF;
   IF (V_CAMPO_58 > 0) THEN
      INSERT INTO ARQMAGNETICO
        (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
      VALUES
        (LPAD('58',10,'0'), V_CABREG2||'58'||LTRIM(REPLACE(TO_CHAR(ROUND(V_CAMPO_58,2),'0000000000000.00'),'.','')), P_NRSEQARQMAG);
      V_CONTREG := V_CONTREG + 1;
   END IF;
   IF (V_CAMPO_59 > 0) THEN
      INSERT INTO ARQMAGNETICO
        (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
      VALUES
        (LPAD('59',10,'0'), V_CABREG2||'59'||LTRIM(REPLACE(TO_CHAR(ROUND(V_CAMPO_59,2),'0000000000000.00'),'.','')), P_NRSEQARQMAG);
      V_CONTREG := V_CONTREG + 1;
   END IF;
   V_VRTOTDEBI := V_CAMPO_51+V_CAMPO_52+V_CAMPO_53+V_CAMPO_54+V_CAMPO_55+V_CAMPO_56+V_CAMPO_57+V_CAMPO_58+V_CAMPO_59;
   IF (V_VRTOTDEBI > 0) THEN
      INSERT INTO ARQMAGNETICO
        (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
      VALUES
        (LPAD('60',10,'0'), V_CABREG2||'60'||LTRIM(REPLACE(TO_CHAR(ROUND(V_VRTOTDEBI,2),'0000000000000.00'),'.','')), P_NRSEQARQMAG);
      V_CONTREG := V_CONTREG + 1;
   END IF;
   /*** QUADRO 10 - CRDITOS DE ICMS ***/
   IF (V_CAMPO_61 > 0) THEN
      INSERT INTO ARQMAGNETICO
        (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
      VALUES
        (LPAD('61',10,'0'), V_CABREG2||'61'||LTRIM(REPLACE(TO_CHAR(ROUND(V_CAMPO_61,2),'0000000000000.00'),'.','')), P_NRSEQARQMAG);
      V_CONTREG := V_CONTREG + 1;
   END IF;
   IF (V_CAMPO_62 > 0) THEN
      INSERT INTO ARQMAGNETICO
        (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
      VALUES
        (LPAD('62',10,'0'), V_CABREG2||'62'||LTRIM(REPLACE(TO_CHAR(ROUND(V_CAMPO_62,2),'0000000000000.00'),'.','')), P_NRSEQARQMAG);
      V_CONTREG := V_CONTREG + 1;
   END IF;
   IF (V_CAMPO_63 > 0) THEN
      INSERT INTO ARQMAGNETICO
        (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
      VALUES
        (LPAD('63',10,'0'), V_CABREG2||'63'||LTRIM(REPLACE(TO_CHAR(ROUND(V_CAMPO_63,2),'0000000000000.00'),'.','')), P_NRSEQARQMAG);
      V_CONTREG := V_CONTREG + 1;
   END IF;
   IF (V_CAMPO_64 > 0) THEN
      INSERT INTO ARQMAGNETICO
        (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
      VALUES
        (LPAD('64',10,'0'), V_CABREG2||'64'||LTRIM(REPLACE(TO_CHAR(ROUND(V_CAMPO_64,2),'0000000000000.00'),'.','')), P_NRSEQARQMAG);
      V_CONTREG := V_CONTREG + 1;
   END IF;
   IF (V_CAMPO_65 > 0) THEN
      INSERT INTO ARQMAGNETICO
        (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
      VALUES
        (LPAD('65',10,'0'), V_CABREG2||'65'||LTRIM(REPLACE(TO_CHAR(ROUND(V_CAMPO_65,2),'0000000000000.00'),'.','')), P_NRSEQARQMAG);
      V_CONTREG := V_CONTREG + 1;
   END IF;
   IF (V_CAMPO_66 > 0) THEN
      INSERT INTO ARQMAGNETICO
        (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
      VALUES
        (LPAD('66',10,'0'), V_CABREG2||'66'||LTRIM(REPLACE(TO_CHAR(ROUND(V_CAMPO_66,2),'0000000000000.00'),'.','')), P_NRSEQARQMAG);
      V_CONTREG := V_CONTREG + 1;
   END IF;
   IF (V_CAMPO_67 > 0) THEN
      INSERT INTO ARQMAGNETICO
        (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
      VALUES
        (LPAD('67',10,'0'), V_CABREG2||'67'||LTRIM(REPLACE(TO_CHAR(ROUND(V_CAMPO_67,2),'0000000000000.00'),'.','')), P_NRSEQARQMAG);
      V_CONTREG := V_CONTREG + 1;
   END IF;
   IF (V_CAMPO_68 > 0) THEN
      INSERT INTO ARQMAGNETICO
        (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
      VALUES
        (LPAD('68',10,'0'), V_CABREG2||'68'||LTRIM(REPLACE(TO_CHAR(ROUND(V_CAMPO_68,2),'0000000000000.00'),'.','')), P_NRSEQARQMAG);
      V_CONTREG := V_CONTREG + 1;
   END IF;
   IF (V_CAMPO_69 > 0) THEN
      INSERT INTO ARQMAGNETICO
        (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
      VALUES
        (LPAD('69',10,'0'), V_CABREG2||'69'||LTRIM(REPLACE(TO_CHAR(ROUND(V_CAMPO_69,2),'0000000000000.00'),'.','')), P_NRSEQARQMAG);
      V_CONTREG := V_CONTREG + 1;
   END IF;
   V_VRTOTCRED := V_CAMPO_61+V_CAMPO_62+V_CAMPO_63+V_CAMPO_64+V_CAMPO_65+V_CAMPO_66+V_CAMPO_67+V_CAMPO_68+V_CAMPO_69;
   IF (V_VRTOTCRED > 0) THEN
      INSERT INTO ARQMAGNETICO
        (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
      VALUES
        (LPAD('70',10,'0'), V_CABREG2||'70'||LTRIM(REPLACE(TO_CHAR(ROUND(V_VRTOTCRED,2),'0000000000000.00'),'.','')), P_NRSEQARQMAG);
      V_CONTREG := V_CONTREG + 1;
   END IF;
   /*** QUADRO 11 - APURAO DO ICMS NO PERODO ***/
   IF (V_CAMPO_80 > 0) THEN
      INSERT INTO ARQMAGNETICO
        (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
      VALUES
        (LPAD('80',10,'0'), V_CABREG2||'80'||LTRIM(REPLACE(TO_CHAR(ROUND(V_CAMPO_80,2),'0000000000000.00'),'.','')), P_NRSEQARQMAG);
      V_CONTREG := V_CONTREG + 1;
   END IF;
   IF (V_CAMPO_90 > 0) THEN
      INSERT INTO ARQMAGNETICO
        (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
      VALUES
        (LPAD('90',10,'0'), V_CABREG2||'90'||LTRIM(REPLACE(TO_CHAR(ROUND(V_CAMPO_90,2),'0000000000000.00'),'.','')), P_NRSEQARQMAG);
      V_CONTREG := V_CONTREG + 1;
   END IF;
   /*** FIM REGISTRO TIPO 2 ***/
   SELECT COUNT(*)
     INTO V_COUNT
     FROM ARQMAGNETICO
    WHERE NRSEQARQMAG = P_NRSEQARQMAG
      AND SUBSTR(DSREGARQMAG,1,19) = V_CABREG2;

   IF (V_COUNT >= 0) THEN
      INSERT INTO ARQMAGNETICO
        (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
      VALUES
        (LPAD('00',10,'0'), V_REGISTRO1||LPAD(NVL(V_COUNT,0),2,'0'), P_NRSEQARQMAG);
   END IF;
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('ARQUIVO_GIA_PR','5.55.000'); END;
/